;
; lib.asm
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
; Library routines for shell utilities
;
;    This file is part of the IDE64 shell utilities.
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

p1		= $14

		*=$0801

		.word sg, 2010
		.null $9e, ^start
sg		.word 0

start		.proc
		lda #<banner
		ldy #>banner
		jsr $ab1e
		lda #<argtxt
		ldy #>argtxt
		jsr $ab1e
		ldy #0
		sty $7a
		lda #2
		sta $7b
		dey
-		iny
		jsr $ffcf
		sta ($7a),y
		eor #13
		bne -
		sta ($7a),y
		iny
		iny
		sta ($7a),y
		lda #13
		jsr $ffd2
		jmp start2

argtxt		.null 13,"arguments:"
		.pend
;
; Parse arguments
;
; "quoted text"
; >tofile
; >>appendfile
;
parseargs	.proc
		stx p1
		sty p1+1
		lda $ba
		sta mydrive
		lda #3
		tax
		ldy #1
		jsr $ffba
		jsr $ffc0
next		ldy #0
		sty redir+1
		sty append+1
		.if WILDEXP
		sty wild+1
		.fi
		ldx #0
		lda ($7a,x)
		bne +
end		txa
		sta (p1,x)
		rts

-		jsr get
+		beq end
		cmp #32
		beq -
		cmp #">"
		bne +
		ror redir+1
		jsr get
		cmp #">"
		bne +
		ror append+1
		jsr get
+
-		cmp #34
		beq q
		iny
		sta (p1),y
		.if WILDEXP
		cmp #"/"
		bne +
		lsr wild+1
+		cmp #"?"
		beq vc
		cmp #"*"
		bne qb
vc		ror wild+1
		.fi
qb		jsr get
		beq kesz
		cmp #32
		bne -
		geq kesz

-		iny
		sta (p1),y
q		jsr get
		beq kesz
		cmp #34
		bne -
		geq qb

kesz            jsr redir
                jmp next

redir		ldx #0
		.if WILDEXP
                bpl wild
		.else
		bpl termstring
                .fi
		lsr redir+1
append		lda #0
		php
		bpl napp
		lda #","
		iny
		sta (p1),y
		lda #"a"
		iny
		sta (p1),y
napp		lsr append+1
		tya
		ldx p1
		ldy p1+1
		inx
		bne *+3
		iny
		jsr $ffbd
		lda #3
		jsr $ffc3
		ldx #1
		plp
		bpl +
		inx
+		stx $b9
		lda mydrive
		sta $ba
		jmp $ffc0

		.if WILDEXP
wild		lda #0
		bpl termstring
		lda #"$"
		sta (p1,x)
		iny
		tya
		ldx p1
		ldy p1+1
		jmp dirlist
                .fi

get		inc $7a
		bne +
		inc $7b
+		lda ($7a,x)
		rts
		.pend

termstring      .proc
		tya
                ldx #0
		sta (p1,x)

addstring       .proc
		sec
		adc p1
		sta p1
		bcc +
		inc p1+1
+		rts
                .pend

mydrive		.proc
		.byte 0
		.pend
myin		.proc
		.byte 0
		.pend
myout		.proc
		.byte 3
		.pend
;
; List directory content
;
dirlist		.proc
		jsr $ffbd
		ldy #0
		sty pathend
-		lda ($bb),y
		cmp #","
		bne +
		lda #"="
		sta ($bb),y
+		cmp #"/"
		bne +
		sty pathend
+		iny
		cpy $b7
		blt -
		lda #16
		ldx mydrive
		tay
		jsr $ffba
		jsr $ffc0
		ldx $b8
		jsr $ffc6

		ldy #6
		jsr skip
readline
-		lda $90
		bne end
		jsr $ffcf
		bne -
		ldy #4
		jsr skip
-		lda $90
		bne end
		jsr $ffcf
		beq end
		cmp #34
		bne -
-		cpy pathend
		bge +
		iny
		lda ($bb),y
		sta (p1),y
		glt -
+		ldx #0
-		jsr $ffcf
		beq end
		iny
		inx
		sta (p1),y
		cmp #34
		bne -
		lda #","
		sta (p1),y
-		jsr $ffcf
		inx
		cpx #19
		blt -
		iny
		sta (p1),y
		cpx #21
		blt -
                jsr termstring
		jmp readline

end		ldy #0
		tya
		sta (p1),y
		jsr $ffcc
		lda $b8
		jmp $ffc3

skip		jsr $ffcf
		dey
		bne skip
		rts

pathend		.byte 0
		.pend
;
; Execute command on command channel, and print result
;
readerr		.proc
		jsr $ffbd
		lda #15
		ldx mydrive
		tay
		jsr $ffba
		jsr $ffc0
		ldx #15
		jsr $ffc6
		jsr $ffcf
		pha
		lsr
		cmp #$18
		bne +
		pla
-		jsr $ffcf
		lda $90
		beq -
		gne en
+
		ldx #3
		jsr $ffc9
		pla
		gcc +

-		jsr $ffcf
+		jsr $ffd2
		lda $90
		beq -
en		jsr $ffcc
		lda #15
		jmp $ffc3
		.pend

read		.proc
		stx readlp+1
		sty rh+1
		tax
		lda $00,x
		sta xj+1
		lda $01,x
		sta xj+2
		jsr is_ide64
unsupp		ora #0
		bne errr
		txa
		ldx readlp+1
		jsr $def4
		bcc exit
		inc unsupp+1

		ldx myin
		jsr $ffc6

errr		ldx #0
		ldy #0
		sty $90

readlp		lda #0
		bne np
rh		lda #0
		beq exit
		dec rh+1
np		dec readlp+1
		jsr $ffcf
xj		sta $ffff,x
		lda $90
		bne exit2
		inx
		bne readlp
		iny
		inc xj+2
		bne readlp
exit		rts

exit2		eor #$40
		bne +
		inx
		bne +
		iny
+		rts
		.pend
;-----------------------------------
write		.proc
		stx readlp+1
		sty rh+1
		tax
		lda $00,x
		sta xj+1
		lda $01,x
		sta xj+2
		jsr is_ide64
unsupp		ora #0
		bne errr
		txa
		ldx readlp+1
		jsr $def1
		bcc exit
		inc unsupp+1

		ldx myout
		jsr $ffc9

errr		ldx #0
		ldy #0
		sty $90

readlp		lda #0
		bne np
rh		lda #0
		beq exit
		dec rh+1
np		dec readlp+1
xj		lda $ffff,x
		jsr $ffd2
		lda $90
		bne exit
		inx
		bne readlp
		iny
		inc xj+2
		bne readlp
exit		rts
		.pend
;-----------------------------------
is_ide64	.proc
		lda $de60
		eor #"i"
		bne eb
		lda $de61
		eor #"d"
		bne eb
		lda $de62
		eor #"e"
eb		rts
		.pend
;-----------------------------------
exit		.proc
		lda #3
		jsr $ffc3
		lda mydrive
		sta $ba
		rts
		.pend
